<?php
// ************* METTRE ICI LES PARAMETRES PROPRE A JEEDOM 
// URL_JEEDOM doit être de la même forme que celle sous votre navigateur internet
// Ex: http://192.168.0.1/jeedom ou bien http://192.168.0.1:435/jeedom
// ou encore http://192.168.0.1 ou encore http://192.168.0.1:2345
$URL_JEEDOM = 'METTRE L URL COMPLETE ICI';

// API KEY EST DISPO SOUS VOTRE CONFIGURATION JEEDOM
$API_KEY 	= 'VOTRE API KEY';

// FICHIER_XML est le nom du fichier de destination 
// Par défaut, vous pouvez laisser comme ca
// Accessible à cet endroit : URL_JEEDOM/plugins/script/core/ressources/FICHIER_XML
$FICHIER_XML = "Export_info.xml";

// ************* FIN DES PARAMETRES

require_once dirname(__FILE__) . '/../../../../core/php/core.inc.php';

function Open_File ($fic) {
	$chemin = dirname(__FILE__); //chemin ou enregistrer le fichier json
	$handle = fopen($chemin.'/'.$fic, 'w');
	return $handle;
}

function Write_File ($handle,$A_ecrire) {
	fwrite($handle,$A_ecrire);
}

function Close_File ($handle) {
	Write_File ($handle,"\r\n</result>");
	fclose($handle); 
}

function Extract_category($tab) {
	$Category="";
	foreach ($tab as $Val_tab =>$num_val){
		if ($num_val == 1) {
			$Category.=$Val_tab.",";
		}
	}
	if ($Category == ""){
		$Category="sans";
	}
return $Category;
}


$jsonrpc = new jsonrpcClient($URL_JEEDOM.'/core/api/jeeApi.php', $API_KEY);
if($jsonrpc->sendRequest('object::full', array())){
	$parsed_json = json_decode(trim($jsonrpc->getRawResult()),true);
//	print_r($parsed_json);

//	Ouverture du fichier de destination
	$handle  = Open_File($FICHIER_XML);
	$Ecrire  = '<?xml version="1.0" encoding="UTF-8"?>';
	$Ecrire = $Ecrire ."\r\n<result>";
	$Ecrire = $Ecrire ."\r\n<date>".date ("Ymd")."</date>";
	$Ecrire = $Ecrire ."\r\n<time>".date ("His")."</time>";

	foreach ($parsed_json['result'] as $Num_Result => $Val_Result)
	{
		$Result_ID = $parsed_json['result'][$Num_Result]['id'];
		$Result_ID_name = $parsed_json['result'][$Num_Result]['name'];

		if ((isset($parsed_json['result'][$Num_Result]['eqLogics'])) && !(empty($parsed_json['result'][$Num_Result]['eqLogics']))&& (is_array($parsed_json['result'][$Num_Result]['eqLogics'])))
		{
		// **********************************
		// passage dans l'arbre des eqLogics
		// **********************************
		foreach ($parsed_json['result'][$Num_Result]['eqLogics'] as $Eq =>$Eq_Num)
			{
				$Eqlogic_id 		= $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['id'];
				$Eqlogic_name 		= $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['name'];
				$Eqlogic_Type_name 	= $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['eqType_name'];
				$Eqlogic_object_id 	= $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['object_id'];
				$Eqlogic_object_id 	= $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['object_id'];
				$Eqlogic_object_category = Extract_category($parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['category']);

				// **********************************
				// passage dans l'arbre des commandes
				// **********************************
				if ((isset($parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'])) && !(empty($parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds']))&& (is_array($parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'])))
				{
				foreach ($parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'] as $Num_cmds =>$Val_cmds)
					{
					$EqLogic_cmd_Id 		= $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'][$Num_cmds]['id'];
					$EqLogic_cmd_LogicalId 	= $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'][$Num_cmds]['logicalId'];
					$EqLogic_cmd_eqtype 	= $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'][$Num_cmds]['eqType'];
					$cmd_name_exist 		= $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'][$Num_cmds]['name'];
					if (isset($cmd_name_exist))
						{
						$EqLogic_cmd_name = $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'][$Num_cmds]['name'];
						}
					$cmd_type_exist = $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'][$Num_cmds]['type'];
					if ((isset($cmd_type_exist)) && ($cmd_type_exist='info'))
						{
						$EqLogic_cmd_name_unite = $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'][$Num_cmds]['unite'];
						$EqLogic_cmd_name_state = $parsed_json['result'][$Num_Result]['eqLogics'][$Eq]['cmds'][$Num_cmds]['state'];
						}

					//Fin des recherche donc mise en forme des données
					//	echo ('<br>');
					//	echo('Result_ID : '.$Result_ID.'<br>');
					//	echo('ID_name : '.$Result_ID_name.'<br>');
					//	echo('Eqlogic_id : '.$Eqlogic_id.'<br>');
					//	echo('Eqlogic_name : '.$Eqlogic_name.'<br>');
					//	echo('Eqlogic_Type_name : '.$Eqlogic_Type_name.'<br>');
					//	echo('Eqlogic_object_id : '.$Eqlogic_object_id.'<br>');
					//	echo('Eqlogic_object_category : '.$Eqlogic_object_category.'<br>');
					//	echo('EqLogic_cmd_Id : '.$EqLogic_cmd_Id.'<br>');
					//	echo('EqLogic_cmd_LogicalId : '.$EqLogic_cmd_LogicalId.'<br>');
					//	echo('EqLogic_cmd_eqtype : '.$EqLogic_cmd_eqtype.'<br>');
					//	echo('EqLogic_cmd_name : '.$EqLogic_cmd_name.'<br>');
					//	echo('EqLogic_cmd_name_unite : '.$EqLogic_cmd_name_unite.'<br>');
					//	echo('EqLogic_cmd_name_state : '.$EqLogic_cmd_name_state.'<br>');
					// Fin d'affichage des datas

					//Fin des recherche donc mise écriture des données
						$Ecrire = $Ecrire. "\r\n<cmd id='".$EqLogic_cmd_Id."'>";
						$Ecrire = $Ecrire. "\r\t<Parent_ID>".$Result_ID."</Parent_ID>";
						$Ecrire = $Ecrire. "\r\t<Parent_ID_name>".$Result_ID_name."</Parent_ID_name>";
						$Ecrire = $Ecrire. "\r\t<Eqlogic_id>".$Eqlogic_id."</Eqlogic_id>";
						$Ecrire = $Ecrire. "\r\t<Eqlogic_name>".$Eqlogic_name."</Eqlogic_name>";
						$Ecrire = $Ecrire. "\r\t<Eqlogic_object_category>".$Eqlogic_object_category."</Eqlogic_object_category>";
						$Ecrire = $Ecrire. "\r\t<EqLogic_cmd_name>".$EqLogic_cmd_name."</EqLogic_cmd_name>";
						$Ecrire = $Ecrire. "\r\t<EqLogic_cmd_name_state>".$EqLogic_cmd_name_state."</EqLogic_cmd_name_state>";
						$Ecrire = $Ecrire. "\r\t<EqLogic_cmd_name_unite>".$EqLogic_cmd_name_unite."</EqLogic_cmd_name_unite>";
						$Ecrire = $Ecrire. "\r</cmd>";
						Write_File ($handle,$Ecrire);
						$Ecrire="";
					}
				}
			}
		}
	}
Close_File ($handle);
}else{
   echo $jsonrpc->getError();
}
